package asd_library;

/**
 * Wrapper class for use with generic data structures.
 */

public class BaseObject implements Comparable {

  private int key;

  /**
   * Constructs the BaseObject.
   * @param k the initial value.
   */
  public BaseObject(int k) {
    this.setKey(k);
    }

    /**
     * Sets key to k
     * @param k
     */
    public void setKey(int k) {
    key = k;
    }

  /**
   * Gets the stored int value.
   * @return the stored value.
   */
   public int intValue(){
     return key;
     }

  /**
   * Implements the compareTo method.
   * @param bo the other BaseObject object.
   * @return 0 if two objects are equal;
   *     less than zero if this object is smaller;
   *     greater than zero if this object is larger.
   * @exception ClassCastException if bo is not
   *     a BaseObject.
   */
  public int compareTo(Object bo) {
    if(!(bo instanceof BaseObject))
      throw new ClassCastException();
    if(this.key == ((BaseObject)bo).key)
      return 0;
      else if(this.key < ((BaseObject)bo).key)
        return -1;
            else return 1;
  }

  /**
   * Implements the toString method.
   * @return the String representation.
   */
  public String toString() {
     return "" + key + " ";
   }

  public void visit() {
    System.out.print(this.toString());
  }

  /**
   * Implements the equals method.
         * @param anotherBaseObject the second BaseObject.
         * @return true if the objects are equal, false otherwise.
         * @exception ClassCastException if anotherBaseObject is not
         *     a BaseObject.
         */
public boolean equals(BaseObject anotherBaseObject) {
            return this.key == anotherBaseObject.key;
    }
}
