package asd_library.queue;

/**
 * The abstract data type queue.
 */

public interface Queue_adt {

  /**
   * Stores an item at the queue end.
   * @param el the object to store.
   */
  void enqueue(Object el);

  /**
   * Retrieves the item from the queue head and removes it.
   * @return the object deleted from the queue.
   */
  Object dequeue();

  /**
   * Retrieves the item from the queue head but doesn't remove it.
   * @return the object at the head of the queue.
   */
  Object firstEl();

  /**
   * Verifies if the queue is empty.
   * @return true if the queue is empty, false otherwise.
   */
  boolean isEmpty();

}