package asd_library.tree.bstree;

/**
 * The abstract data type of a Binary Search tree.
 */

public interface BSTree_adt extends asd_library.dictionary.Dictionary_adt{

  /**
     * Method to get element field.
     * @param v the node.
     * @return the element field or null if this node is null.
     */
  Comparable element(BSTNode v);

  /**
   * Returns the root of this tree.
   * @return the root node.
   */
  BSTNode root();


   /**
   *Verifies if the node v is a leaf.
     * @param v the node
     * @return true if v is a leaf, false otherwise.
   */
  boolean isLeaf(BSTNode v);

  /**
   *Verifies if the node v is the root.
   * @param v the node
   * @return true if v is the root, false otherwise.
   */
  boolean isRoot(BSTNode v);

}
