package asd_library.tree.tree;

import java.util.ListIterator;

/**
 *  The abstract data type of a generic tree.
 */

public interface Tree_adt {

  /**
   * method to get element field.
   * @param v the node.
   * @return the element field or null if this node is null.
   */
  Comparable element(TreeNode v);

  /**
   * Returns the root of this tree.
   * @return the root node.
   */
  TreeNode root();

  /**
   * Return the parent node of node v
   * @param the TreeNode v
   * @return the TreeNode that is v's parent .
   */
  TreeNode parent(TreeNode v);
  ListIterator children(TreeNode v);

  /**
   * Verifies if the node v is a leaf.
   * @param v the node
   * @return true if v is a leaf, false otherwise.
   */
  boolean isLeaf(TreeNode v);

  /**
   * Verifies if the node v is the root.
   * @param v the node
   * @return true if v is the root, false otherwise.
   */
  boolean isRoot(TreeNode v);

}